###############################################################################
# Coscine Python SDK
# Copyright (c) 2018-2022 RWTH Aachen University
# Licensed under the terms of the MIT License
# #############################################################################
# Coscine, short for Collaborative Scientific Integration Environment is
# a platform for research data management (RDM).
# For more information on Coscine visit https://www.coscine.de/.
#
# Please note that this python module is open source software primarily
# developed and maintained by the scientific community. It is not
# an official service that RWTH Aachen provides support for.
###############################################################################

###############################################################################
# File description
###############################################################################

"""
This file contains a couple of unittests to verify the Coscine Python SDK
is working accordingly. Furthermore it can be used to test whether a Coscine
instance is broken or unreachable.
"""

# This is still WIP

###############################################################################
# Dependencies
###############################################################################

import unittest
import coscine
import os

###############################################################################
# Class
###############################################################################

class CoscineTest(unittest.TestCase):
	client_no_valid_token: coscine.Client

###############################################################################

	def setUp(self) -> None:
		self.client_no_valid_token = coscine.Client("NotAValidToken")

###############################################################################

	def test___init__(self):
		self.assertIsInstance(self.client_no_valid_token, coscine.Client)
		self.assertIsInstance(self.client_no_valid_token.version, str)

###############################################################################

	def test_projects(self):
		with self.assertRaises(coscine.AuthorizationError):
			self.client_no_valid_token.projects()

# Main
###############################################################################

if __name__ == "__main__":
	unittest.main()

###############################################################################